Package: BREW3R.r
Type: Package
Title: R package associated to BREW3R
Version: 1.9.0
Authors@R: 
    person(given = "Lucille",
           family = "Lopez-Delisle",
           role = c("aut", "cre"),
           email = "lucille.delisle@epfl.ch",
           comment = c(ORCID = "0000-0002-1964-4960"))
Description: This R package provide functions that are used in the BREW3R
    workflow. This mainly contains a function that extend a gtf as GRanges using
    information from another gtf (also as GRanges). The process allows to extend
    gene annotation without increasing the overlap between gene ids.
License: GPL-3
Encoding: UTF-8
RoxygenNote: 7.3.1
Imports: GenomicRanges, methods, rlang, S4Vectors, utils
Suggests: testthat (>= 3.0.0), IRanges, knitr, rmarkdown, BiocStyle,
        rtracklayer
biocViews: GenomeAnnotation
Config/testthat/edition: 3
URL: https://github.com/lldelisle/BREW3R.r
BugReports: https://github.com/lldelisle/BREW3R.r/issues/
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/BREW3R.r
git_branch: devel
git_last_commit: ccdaccc
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:35:37 UTC; biocbuild
Author: Lucille Lopez-Delisle [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-1964-4960>)
Maintainer: Lucille Lopez-Delisle <lucille.delisle@epfl.ch>

# BREW3R.r
The BREW3R.r package has been written to be part of the BREW3R workflow. Today, the package contains a single function which enable to extend three prime of gene annotations using another gene annotation as template. This is very helpful when you are using a technique that only sequence three-prime end of genes like 10X scRNA-seq or BRB-seq.

## Installation

To install from Bioconductor use:

```{r installation bioconductor, eval=FALSE}
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("BREW3R.r")
```

To install from github use:

```{r installation github, eval=FALSE}
if (!require("devtools", quietly = TRUE))
    install.packages("devtools")

devtools::install_github("lldelisle/BREW3R.r")
```

## Issues
If you have issues, use the Issues in github or send an email to lucille.delisle\@epfl.ch

# This file is part of the standard setup for testthat.
# It is recommended that you do not modify it.
#
# Where should you do additional test configuration?
# Learn more about the roles of various files in:
# * https://r-pkgs.org/testing-design.html#sec-tests-files-overview
# * https://testthat.r-lib.org/articles/special-files.html

library(testthat)
library(BREW3R.r)

test_check("BREW3R.r")

#' Display debug messages if verbose allows it
#'
#' A function that extend rlang::inform
#' to display a message if the verbose is at "debug"
#' and show content of the variable
#' @param message String to display
#' @param ... Other parameters for rlang::inform
#' @return Nothing
debug_msg <- function(message = NULL, ...) {
    is_debug_mode <- (getOption("BREW3R.r.verbose", "quiet") == "debug")
    if (is_debug_mode) {
        rlang::local_options(rlib_message_verbosity = "verbose")
        rlang::inform(message = message, ...)
        if (exists(message)) {
            methods::show(eval(parse(text = message)))
        }
    }
}
#' Display progression messages if verbose allows it
#'
#' A function that extend rlang::inform
#' to display a message if the verbose is at "debug" or "progression"
#' @param ... Parameters for rlang::inform
#' @return Nothing
progression_msg <- function(...) {
    is_progression_or_debug_mode <-
        (getOption("BREW3R.r.verbose", "quiet") %in% c("debug", "progression"))
    if (is_progression_or_debug_mode) {
        rlang::local_options(rlib_message_verbosity = "verbose")
        rlang::inform(...)
    }
}

#' Get three prime position
#'
#' A function that from a GRanges
#' gives the 3' position
#' @param input_gr A GRanges or GRangeList
#' @return A vector of integers
three_prime_pos <- function(input_gr) {
    return(GenomicRanges::start(
        GenomicRanges::resize(input_gr, width = 1, fix = "end")
    ))
}

#' Get five prime position
#'
#' A function that from a GRanges
#' gives the 5' position
#' @param input_gr A GRanges or GRangeList
#' @return A vector of integers
five_prime_pos <- function(input_gr) {
    return(GenomicRanges::start(
        GenomicRanges::resize(input_gr, width = 1, fix = "start")
    ))
}

#' Extract last exons
#'
#' A function that from a GRanges from gtf
#' select only entries for the last exons
#' If multiple exons overlap the last base of the grouping_variable,
#' they will all be reported.
#' @param input_gr A GRanges from a gtf
#' @param grouping_variable A string with the name of the metadata
#'                           which should be used to group
#' @param invert A boolean that indicates if you want all except the last exons
#' @return A GRanges which contains a subset of `input_gr`
extract_last_exons <- function(
    input_gr, grouping_variable = "transcript_id", invert = FALSE) {
    # I only work with exons
    exons_gr <- base::subset(
        input_gr,
        with(input_gr, type == "exon")
    )
    # I split by grouping_variable
    exons_gr_group <- GenomicRanges::mcols(exons_gr)[, grouping_variable]
    exons_gr_split <-
        GenomicRanges::split(
            exons_gr,
            exons_gr_group
        )
    # I get the three prime extremity
    group_range <- unlist(range(exons_gr_split))
    group_extremity <- three_prime_pos(group_range)
    names(group_extremity) <- names(group_range)
    indices_last_exons <- which(
        three_prime_pos(exons_gr) ==
            group_extremity[exons_gr_group]
    )
    # Return the corresponding GRanges object
    if (invert) {
        return(exons_gr[-indices_last_exons])
    } else {
        return(exons_gr[indices_last_exons])
    }
}

#' Overlap exons and extend three prime end
#'
#' A function that from 2 GRanges returns a subset of the first
#' GRanges which have been extended using the second GRanges
#' @param input_gr_to_extend A GRanges with exons to extend
#'                           (strand * are excluded)
#' @param input_gr_to_overlap A GRanges with intervals to overlap
#' @return A GRanges which is a subset of `input_gr_to_extend` where
#'         3' end have been modified to match the 3' end of
#'         `input_gr_to_overlap` if they overlap
#'         (initial width have been stored into old_width)
#' @importFrom GenomicRanges strand
#' @importFrom GenomicRanges `strand<-`
extend_using_overlap <- function(input_gr_to_extend, input_gr_to_overlap) {
    # Remove strands which are not in + - and non exonic features
    input_gr_to_extend <- subset(
        input_gr_to_extend,
        with(
            input_gr_to_extend,
            type == "exon" &
                as.character(strand(input_gr_to_extend)) != "*"
        )
    )
    # Remove non-exonic features from input_gr_to_overlap
    input_gr_to_overlap <- subset(
        input_gr_to_overlap,
        with(input_gr_to_overlap, type == "exon")
    )
    rlang::inform(
        paste(
            "Compute overlap between", length(input_gr_to_extend),
            "exons and", length(input_gr_to_overlap), "exons.\n"
        )
    )
    # Compute overlap:
    full_overlap <- suppressWarnings(GenomicRanges::findOverlaps(
        input_gr_to_extend,
        input_gr_to_overlap
    ))
    progression_msg("Split by overlap.\n")
    # Group all overlaps into a single range
    input_gr_to_overlap_intersect <- GenomicRanges::split(
        input_gr_to_overlap[S4Vectors::subjectHits(full_overlap)],
        S4Vectors::queryHits(full_overlap)
    )
    # We need to remove strand in order to enable a single range for
    # ranges with no strand and strand
    strand(input_gr_to_overlap_intersect) <- "*"
    input_gr_to_overlap_intersect_range <-
        unlist(range(input_gr_to_overlap_intersect))
    # Select the corresponding to_extend
    input_gr_to_extend_intersect <-
        input_gr_to_extend[unique(S4Vectors::queryHits(full_overlap))]
    # Calculate the potential_extension
    potential_extention <- ifelse(
        strand(input_gr_to_extend_intersect) == "+",
        GenomicRanges::end(input_gr_to_overlap_intersect_range) -
            GenomicRanges::end(input_gr_to_extend_intersect),
        GenomicRanges::start(input_gr_to_extend_intersect) -
            GenomicRanges::start(input_gr_to_overlap_intersect_range)
    )
    # Select only true extension
    input_gr_to_extend_intersect_selected <-
        input_gr_to_extend_intersect[potential_extention > 0]
    potential_extention_selected <-
        potential_extention[potential_extention > 0]
    # Store old width
    input_gr_to_extend_intersect_selected$old_width <-
        GenomicRanges::width(input_gr_to_extend_intersect_selected)
    # Extend
    input_gr_to_extend_intersect_selected_extended <-
        GenomicRanges::resize(
            input_gr_to_extend_intersect_selected,
            width =
                input_gr_to_extend_intersect_selected$old_width +
                    potential_extention_selected
        )
    return(input_gr_to_extend_intersect_selected_extended)
}

#' Get overlaps from different genes
#'
#' A function that from 2 GRanges generates a dataframe
#' With queryHits, subjectHits when the gene_id is different
#' @param gr1 A GRanges with 'gene_id'
#' @param gr2 A GRanges with 'gene_id'
#' @return a data.frame with overlaps between gr1 and gr2 when gene_id from gr1
#'         is different from gene_id from gr2. The data.frame has 4 columns:
#'         `queryHits`, `subjectHits`, `query_gene_id` and `subject_gene_id`
overlap_different_genes <- function(gr1, gr2) {
    # Compute overlap
    ov <- suppressWarnings(GenomicRanges::findOverlaps(gr1, gr2))
    ov_df <- as.data.frame(ov)
    ov_df$query_gene_id <- gr1$gene_id[ov_df$queryHits]
    ov_df$subject_gene_id <- gr2$gene_id[ov_df$subjectHits]
    return(subset(
        ov_df,
        with(ov_df, query_gene_id != subject_gene_id)
    ))
}



#' Adjust for collision
#'
#' A function that from a GRanges with 'old_width'
#' Change the starts and ends to prevent collisions larger than
#' with old coordinates
#' @param input_gr A GRanges with 1 meta: 'old_width'
#' @return A list with:
#'         - 'pot_issues': A dataframe with exons which overlaps between
#'                        `input_gr` and itself while gene_ids are different
#'         - 'new_gr': A GRanges identical to `input_gr` except that start/end
#'                     have been adjusted to prevent collisions.
adjust_for_collision <- function(input_gr) {
    # Use an 'id':
    input_gr$id <- paste0(input_gr$exon_id, "_", input_gr$transcript_id)
    # Select entries which have been extended:
    extended_gr <- subset(
        input_gr, with(input_gr, old_width < width)
    )
    # Select only the extension
    extension_gr <- GenomicRanges::resize(
        extended_gr,
        GenomicRanges::width(extended_gr) - extended_gr$old_width,
        fix = "end"
    )
    # Select the first base of extension
    first_base_extension_gr <-
        GenomicRanges::resize(
            extension_gr,
            width = 1
        )
    # Generate the original input
    original_gr <-
        GenomicRanges::resize(
            input_gr,
            width = input_gr$old_width
        )

    # Compute overlap between first base of extension and original
    # and get those from different gene_ids:
    pot_issues_first <- overlap_different_genes(
        first_base_extension_gr,
        original_gr
    )
    pot_issues_first$query_id <-
        first_base_extension_gr[pot_issues_first$queryHits]$id
    # These should not be extended
    # Restore them
    to_restore <- which(input_gr$id %in% pot_issues_first$query_id)
    input_gr[to_restore] <-
        original_gr[to_restore]
    # Store this into a data frame
    pot_issues_df <- as.data.frame(input_gr[to_restore])
    if (nrow(pot_issues_df) > 0) {
        pot_issues_df$issue <- "first_base_extension_overlaps_different_gene"
        pot_issues_df$solution <- "no extension"
        pot_issues_df$collision_base <- NA
    }
    # Select entries which have been extended:
    extended_gr <- subset(
        input_gr, with(input_gr, old_width < width)
    )
    # Select only the extension
    extension_gr <- GenomicRanges::resize(
        extended_gr,
        GenomicRanges::width(extended_gr) - extended_gr$old_width,
        fix = "end"
    )
    # To deal with tail-to-head extensions we
    # compute overlap between extension and five prime of input_gr
    # and get those from different gene_ids:
    pot_issues <- overlap_different_genes(
        extension_gr,
        GenomicRanges::resize(
            input_gr,
            width = 1
        )
    )

    if (nrow(pot_issues) > 0) {
        overlapped_range <- unlist(range(
            GenomicRanges::split(
                input_gr[pot_issues$subjectHits],
                pot_issues$queryHits
            )
        ))
        # Generate a GRanges with issues:
        extended_gr_issues <- extended_gr[as.numeric(names(overlapped_range))]
        extended_gr_issues$collision_base <- five_prime_pos(overlapped_range)
        # Compute the new_widths to avoid tail-to-head
        new_widths <- abs(extended_gr_issues$collision_base -
            five_prime_pos(extended_gr_issues))
        names(new_widths) <- extended_gr_issues$id
        # Modify the input_gr
        input_gr[match(names(new_widths), input_gr$id)] <-
            GenomicRanges::resize(
                input_gr[match(names(new_widths), input_gr$id)],
                new_widths
            )
        # Store solving into a data.frame
        pot_issues_df_temp <- as.data.frame(extended_gr_issues)
        pot_issues_df_temp$issue <- "tail_to_head_collision"
        pot_issues_df_temp$solution <- "smaller extension"
        pot_issues_df <- rbind(pot_issues_df, pot_issues_df_temp)
    }
    # Now we compute overlap between extension and input_gr
    # We can restrict to exons with issues:
    new_extended_gr <- subset(
        input_gr, with(input_gr, old_width < width)
    )
    # Select only the extension
    new_extension_gr <- GenomicRanges::resize(
        new_extended_gr,
        GenomicRanges::width(new_extended_gr) - new_extended_gr$old_width,
        fix = "end"
    )
    new_pot_issues <- overlap_different_genes(
        new_extension_gr,
        input_gr
    )

    if (nrow(new_pot_issues) > 0) {
        # The only case that is remaining:
        # old
        # ----->
        #  ---->
        # new
        # ------------->
        #  ------------>
        new_pot_issues$query_id <-
            new_extension_gr$id[new_pot_issues$queryHits]
        to_restore <- which(input_gr$id %in% new_pot_issues$query_id)
        input_gr[to_restore] <-
            original_gr[to_restore]
        pot_issues_df_temp <-
            as.data.frame(new_extension_gr[new_pot_issues$queryHits])
        pot_issues_df_temp$issue <- "both_equal_extension"
        pot_issues_df_temp$solution <- "no extension"
        pot_issues_df_temp$collision_base <- NA
        pot_issues_df <- rbind(pot_issues_df, pot_issues_df_temp)
    }
    # Remove the id:
    input_gr$id <- NULL
    return(list(
        pot_issues = pot_issues_df,
        new_gr = input_gr
    ))
}

#' Filter new exons for collision
#'
#' A function that from 2 GRanges filter exons from the first one
#' so they do not go three prime to the first collision with the second one.
#' @param all_exons_interesting A GRanges with exons to trim and filter
#' @param input_gr_to_extend A GRanges to overlap
#' @return A GRanges subset of `all_exons_interesting`
filter_new_exons <- function(all_exons_interesting, input_gr_to_extend) {
    progression_msg(
        "Check added exons which would overlap existing annotations.\n"
    )
    # Check that the new exons do not overlap existing annotations
    # ov_new_exons is the overlap between:
    # queries = all_exons_interesting
    # subjects = input_gr_to_extend
    # We arbitrarily decide to not include new exons if they overlap with any
    # existing exons (including those with the same gene_id).
    ov_new_exons <- suppressWarnings(GenomicRanges::findOverlaps(
        all_exons_interesting,
        input_gr_to_extend
    ))

    input_gr_to_extend_intersected <-
        input_gr_to_extend[S4Vectors::subjectHits(ov_new_exons)]

    # Get the five prime end of the intersected by new transcript_id
    input_gr_to_extend_intersected_range <-
        unlist(range(
            GenomicRanges::split(
                input_gr_to_extend_intersected,
                all_exons_interesting$transcript_id[
                    S4Vectors::queryHits(ov_new_exons)
                ]
            )
        ))
    collision_base_per_transcript <- five_prime_pos(
        input_gr_to_extend_intersected_range
    )
    names(collision_base_per_transcript) <-
        names(input_gr_to_extend_intersected_range)
    all_exons_interesting$collision_base <-
        collision_base_per_transcript[all_exons_interesting$transcript_id]
    progression_msg(
        "Remove new candidate exons",
        " three prime of overlap with existing annotations.\n"
    )
    # Filter exons after collision:
    all_exons_interesting <-
        subset(
            all_exons_interesting,
            with(
                all_exons_interesting,
                is.na(collision_base) |
                    (strand == "+" & start < collision_base) |
                    (strand == "-" & end > collision_base)
            )
        )
    rlang::inform(
        paste(
            "Stay", length(unique(all_exons_interesting$id)), "candidate",
            "exons that may be included into",
            length(unique(all_exons_interesting$transcript_id)),
            "transcripts.\n"
        )
    )
    progression_msg(
        paste(
            "Adjust start/end of candidate exons to not",
            "overlap with existing annotations.\n"
        )
    )

    if (length(all_exons_interesting) == 0) {
        return()
    }

    to_adjust <- which(!is.na(all_exons_interesting$collision_base) &
        (GenomicRanges::start(all_exons_interesting) <=
            all_exons_interesting$collision_base) &
        (GenomicRanges::end(all_exons_interesting) >=
            all_exons_interesting$collision_base))

    # Compute the new_widths to avoid tail-to-head
    new_widths <- abs(all_exons_interesting[to_adjust]$collision_base -
        five_prime_pos(all_exons_interesting[to_adjust]))
    # Apply to all_exons_interesting
    all_exons_interesting[to_adjust] <- GenomicRanges::resize(
        all_exons_interesting[to_adjust],
        new_widths
    )
    return(all_exons_interesting)
}

#' Add new exons
#'
#' A function that from 2 GRanges add exons from the second one
#' to the first one
#' if the 3p of the last exon of the transcript in the first GRanges
#' matches the 3p of an exon in the second one
#' @param input_gr_to_extend A GRanges to be complemented
#' @param input_gr_with_new_exons A GRanges with exons to be added
#' to the first one (exons with strand '*' are excluded)
#' @importFrom GenomicRanges strand
#' @return A GRanges identical to `input_gr_to_extend` with new exons
#'         whose `exon_id` contains BREW3R. `exon_number` may have changed.
#' @details
#' Potential new exons will be filtered for collision with exons present
#' in the first GRanges even if they belong to the same gene_id.
#' For the moment all potential exons extensions are added to the
#' same existing transcript_id so introns maybe artificial introns.
#'
add_new_exons <- function(input_gr_to_extend, input_gr_with_new_exons) {
    # Subset input_gr_with_new_exons
    input_gr_with_new_exons <- subset(
        input_gr_with_new_exons,
        strand(input_gr_with_new_exons) != "*"
    )
    # Add an id:
    input_gr_with_new_exons$id <- seq_along(input_gr_with_new_exons)
    progression_msg("Extract last exon of first GRanges.\n")
    # Get the last exons of input_gr_to_extend
    input_gr_last <- extract_last_exons(input_gr_to_extend)
    # First find exons which 'ends' at the same position
    progression_msg("Compute overlap with second GRanges.\n")
    last_base_input_gr_last <-
        GenomicRanges::resize(
            input_gr_last,
            width = 1, fix = "end"
        )
    last_base_input_gr_with_new_exons <-
        GenomicRanges::resize(
            input_gr_with_new_exons,
            width = 1, fix = "end"
        )
    ov <- suppressWarnings(GenomicRanges::findOverlaps(
        last_base_input_gr_last,
        last_base_input_gr_with_new_exons
    ))
    ov_df <- as.data.frame(ov)
    if (nrow(ov_df) == 0) {
        return(input_gr_to_extend)
    }
    progression_msg("Only keep those with exons to be added.\n")
    # First get transcript_id from exon overlapped
    ov_df$subject_transcript_id <-
        input_gr_with_new_exons$transcript_id[ov_df$subjectHits]

    # Get transcript_extremity and transcript_id from input_gr_with_new_exons
    input_gr_with_new_exons_subset <- subset(
        input_gr_with_new_exons,
        with(
            input_gr_with_new_exons,
            transcript_id %in% ov_df$subject_transcript_id
        )
    )
    input_gr_with_new_exons_subset_range <-
        unlist(range(
            GenomicRanges::split(
                input_gr_with_new_exons_subset,
                input_gr_with_new_exons_subset$transcript_id
            )
        ))
    # Remove overlaps where it is the transcript subject extremity
    progression_msg(
        "Remove overlaps where transcript 3' matches between both\n"
    )
    ov_df <- subset(
        ov_df,
        GenomicRanges::start(last_base_input_gr_last[ov_df$queryHits]) !=
            three_prime_pos(
                input_gr_with_new_exons_subset_range[
                    ov_df$subject_transcript_id
                ]
            )
    )
    if (nrow(ov_df) == 0) {
        return(input_gr_to_extend)
    }
    progression_msg("Attribute exons to be added to the good transcript.\n")
    # Get all exons from subject_transcript_id
    # which are after the query_extremity
    # First get all exons of subject_transcript_id
    # (once per queryHits)
    input_gr_with_new_exons_subset <- subset(
        input_gr_with_new_exons,
        with(
            input_gr_with_new_exons,
            transcript_id %in% ov_df$subject_transcript_id
        )
    )
    input_gr_with_new_exons_subset_split <-
        GenomicRanges::split(
            input_gr_with_new_exons_subset,
            input_gr_with_new_exons_subset$transcript_id
        )
    nb_exons_per_transcript <-
        table(input_gr_with_new_exons_subset$transcript_id)
    all_pot_exons <-
        unlist(
            input_gr_with_new_exons_subset_split[ov_df$subject_transcript_id]
        )
    all_pot_exons$queryHits <- rep(
        ov_df$queryHits, nb_exons_per_transcript[ov_df$subject_transcript_id]
    )
    all_pot_exons$three_prime_query <- GenomicRanges::start(
        last_base_input_gr_last[all_pot_exons$queryHits]
    )
    # Filter, I don't know how to do better
    all_exons_interesting <- subset(
        all_pot_exons,
        with(
            all_pot_exons,
            ifelse(strand == "+",
                start > three_prime_query,
                end < three_prime_query
            )
        )
    )
    rlang::inform(
        paste(
            "Found", length(unique(all_exons_interesting$id)), " exons",
            "that may be included into",
            length(unique(all_exons_interesting$queryHits)),
            "transcripts.\n"
        )
    )
    # Attribute the new transcript_id to new exons
    all_exons_interesting$transcript_id <-
        last_base_input_gr_last[all_exons_interesting$queryHits]$transcript_id
    # Filter
    all_exons_interesting <-
        filter_new_exons(all_exons_interesting, input_gr_to_extend)
    if (is.null(all_exons_interesting)) {
        return(input_gr_to_extend)
    }
    # Here I do something which is not ideal:
    # If multiple transcripts could contribute to extension
    # they will be merged into a single one:
    # For example:
    # gene_1:           --->
    # to_overlap_tr_A:  ----/    \-->
    # to_overlap_tr_B:  ----/          \--->
    # Will give
    # gene_1:           ----/    \----/\--->
    # While the second intron is not a real intron...

    progression_msg("Combine exons extending the same transcript.\n")
    all_exons_to_add_gr <- unlist(
        GenomicRanges::reduce(
            GenomicRanges::split(
                all_exons_interesting,
                all_exons_interesting$transcript_id
            )
        )
    )
    all_exons_to_add_gr$transcript_id <- names(all_exons_to_add_gr)
    names(all_exons_to_add_gr) <- NULL

    rlang::inform(
        paste(
            "Finally", length(all_exons_to_add_gr), "combined exons",
            "will be included into",
            length(unique(all_exons_to_add_gr$transcript_id)),
            "transcripts.\n"
        )
    )
    progression_msg("Annotate new exons with transcript info.\n")
    # Add transcript_id infos:
    mcols_input <- as.data.frame(GenomicRanges::mcols(
        input_gr_last[unique(all_exons_interesting$queryHits)]
    ))
    transcript_annotation <-
        unique(
            mcols_input[
                ,
                c(
                    grep("^source$", colnames(mcols_input), value = TRUE),
                    grep("^gene_", colnames(mcols_input), value = TRUE),
                    grep("^transcript_", colnames(mcols_input),
                        value = TRUE
                    )
                )
            ]
        )

    GenomicRanges::mcols(all_exons_to_add_gr) <-
        transcript_annotation[match(
            all_exons_to_add_gr$transcript_id,
            transcript_annotation$transcript_id
        ), ]
    all_exons_to_add_gr$type <- "exon"

    progression_msg("Annotate new exons with exon_id.\n")
    # I add exon_id
    if (any(grepl("BREW3R", input_gr_to_extend$exon_id))) {
        last_id_used <- max(
            as.numeric(
                gsub(
                    gsub(
                        grep("BREW3R",
                            input_gr_to_extend$exon_id,
                            value = TRUE
                        ),
                        pattern = "BREW3R", replacement = ""
                    ),
                    pattern = "[^0-9]", replacement = ""
                )
            )
        )
    } else {
        last_id_used <- 0
    }
    all_exons_to_add_gr$exon_id <-
        paste0(
            "BREW3R",
            sprintf(
                "%010d",
                last_id_used + seq_along(all_exons_to_add_gr)
            )
        )


    progression_msg("Update exon_number.\n")
    # Update exon_number
    # There are 2 exon_number modes:
    # 1. from 5p to 3p (I call it transcript)
    # 2. from start to end whatever the strand is (I call it coordinate)
    # To get the mode I select a second exon with strand -
    if (!"exon_number" %in%
        colnames(GenomicRanges::mcols(input_gr_to_extend))) {
        my_mode <- "transcript"
        gr_to_annotate <- suppressWarnings(
            c(all_exons_to_add_gr, input_gr_to_extend)
        )
        gr_to_add <- NULL
    } else {
        gr_to_annotate <- suppressWarnings(c(
            all_exons_to_add_gr,
            subset(
                input_gr_to_extend,
                with(
                    input_gr_to_extend,
                    transcript_id %in% all_exons_to_add_gr$transcript_id
                )
            )
        ))
        gr_to_add <- subset(
            input_gr_to_extend,
            with(
                input_gr_to_extend,
                !transcript_id %in% all_exons_to_add_gr$transcript_id
            )
        )
        potential_selected_exon <- subset(
            input_gr_to_extend,
            with(
                input_gr_to_extend,
                exon_number == 2 & strand == "-"
            )
        )
        if (length(potential_selected_exon) == 0) {
            my_mode <- "transcript"
        } else {
            selected_exon <- potential_selected_exon[1]
            first_corresponding_exon <-
                subset(
                    input_gr_to_extend,
                    with(
                        input_gr_to_extend,
                        transcript_id == selected_exon$transcript_id &
                            exon_number == 1
                    )
                )
            if (GenomicRanges::start(selected_exon) <
                GenomicRanges::start(first_corresponding_exon)) {
                my_mode <- "transcript"
            } else {
                my_mode <- "coordinate"
            }
        }
    }
    # Order by transcript_id first:
    gr_to_annotate <- gr_to_annotate[
        order(
            gr_to_annotate$transcript_id,
            GenomicRanges::start(gr_to_annotate),
            GenomicRanges::end(gr_to_annotate)
        )
    ]
    if (my_mode == "transcript") {
        gr_to_annotate_plus <-
            subset(
                gr_to_annotate,
                strand(gr_to_annotate) == "+"
            )
        gr_to_annotate_minus <-
            subset(
                gr_to_annotate,
                strand(gr_to_annotate) == "-"
            )
        gr_to_annotate <- c(
            gr_to_annotate_plus,
            rev(gr_to_annotate_minus)
        )
    }
    exons_per_transcript <- table(gr_to_annotate$transcript_id)
    exon_numbers_list <- lapply(exons_per_transcript, seq_len)
    exon_numbers <-
        unlist(exon_numbers_list[unique(gr_to_annotate$transcript_id)])
    gr_to_annotate$exon_number <- unname(exon_numbers)
    new_gr <- c(gr_to_annotate, gr_to_add)

    return(new_gr)
}

options(rlib_message_verbosity = "quiet")
# Define GR Used in different places
input_gr <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(1, 10, 20, 30),
                              end = c(3, 13, 23, 33)),
    strand = rep(c("+", "-"), each = 2),
    gene_id = rep(c("gene1", "gene2"), each = 2),
    transcript_id = c("transcript1", "transcript2",
                      "transcript3", "transcript3"),
    type = "exon"
)

input_gr_to_overlap <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(1, 7, 17, 25, 28),
                              end = c(3, 15, 23, 30, 35)),
    strand = c("+", "+", "+", "-", "-"),
    gene_id = c(rep(c("geneA", "geneB"), each = 2),  "geneC"),
    transcript_id = c("transcriptA", "transcriptB", "transcriptC",
                      "transcriptC", "transcriptD"),
    type = "exon"
)

small_gr_pot_extended <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(10, 25),
                              end = c(15, 33)),
    strand = c("+", "-"),
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript2", "transcript3"),
    type = "exon",
    old_width = c(4, 4)
)
# Case1:
# input_gene1:      ------->
# input_gene2:                    -------->
# to_overlap:  ---------------------->
# or Case 2:
# to_overlap:           ------------------>
# Case 3:
# input_gene1:      ------->                (will be extended by Case1)
# input_gene2:                    ---->
# to_overlap:       ---------------------->
# Case 4:
# input_gene1:      ------->
# input_gene2:      ------------->
# to_overlap:       ---------------------->
# Case 4bis:
# input_gene1:      ------->
# input_gene2:      ------------->
# to_overlap:       ------------->
# Case 5:
# input_gene1:      ------->
# input_gene2:                    -------->
# to_overlap:           ----------------------/\----/\-/\->
# Case 6:
# input_transcript1:     --------->
# input_transcript2:     ----------/        \-------->
# to_overlap:               ----------->
# Case 6bis:
# input_gene1:     --------->
# input_gene2:     ----------/        \-------->
# to_overlap:          ----------->
# Case 7:
# input_transcript1:     ------>
# input_transcript2:     ----------/        \-------->
# to_overlap:               ----------->
# Case 8 should not be extended:
# input_gene1:        ----->
# input_gene2:     ----------------/      \--------
# to_overlap:      ------------------>
# Case 9:
# input_gene1:  --->
# input_gene2:                   --->
# to_overlap:   ----/\--------/\---/  \---->
# Case 10:
# input_gene1:      ------->
# input_gene2:                    -------->
# to_overlap:  ---------------------->
#                          -----------------------
#              <--------------------------------------------


input_gr_case1_10 <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 20),
                              end = c(10, 30)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2")
)
input_gr_case2 <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 20),
                              end = c(10, 25)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2")
)
input_gr_case3_5 <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 20),
                              end = c(10, 22)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2")
)
input_gr_case4 <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 5),
                              end = c(10, 22)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2")
)
input_gr_case4bis <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 5),
                              end = c(10, 25)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2")
)
input_gr_case6 <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(1, 1, 30),
                              end = c(10, 10, 40)),
    strand = "+",
    gene_id = "gene1",
    transcript_id = c("transcript1", "transcript2", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon1", "exon2")
)
input_gr_case6bis <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(1, 1, 30),
                              end = c(10, 10, 40)),
    strand = "+",
    gene_id = c("gene1", "gene2", "gene2"),
    transcript_id = c("transcript1", "transcript2", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2", "exon3")
)
input_gr_case7 <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(1, 1, 30),
                              end = c(8, 10, 40)),
    strand = "+",
    gene_id = "gene1",
    transcript_id = c("transcript1", "transcript2", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2", "exon3")
)
input_gr_case8 <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(1, 1, 30),
                              end = c(8, 10, 40)),
    strand = "+",
    gene_id = c("gene1", "gene2", "gene2"),
    transcript_id = c("transcript1", "transcript2", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2", "exon3")
)
input_gr_case9 <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 55),
                              end = c(10, 70)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2")
)
input_to_overlap_case1_2_3_4_6_7_8 <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = 3,
                              end = 25),
    strand = "+",
    gene_id = "geneA",
    transcript_id = "transcriptA",
    type = "exon",
    exon_id = "exonA"
)
input_to_overlap_case5_9 <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(1, 33, 45, 72),
                              end = c(25, 40, 60, 75)),
    strand = "+",
    gene_id = "geneA",
    transcript_id = "transcriptA",
    type = "exon",
    exon_id = c("exonA", "exonB", "exonC", "exonD")
)
input_to_overlap_case10 <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(3, 10, 1),
                              end = c(25, 50, 70)),
    strand = c("+", "*", "-"),
    gene_id = c("geneA", "geneB", "geneC"),
    transcript_id = c("transcriptA", "transcriptB", "transcriptC"),
    type = "exon",
    exon_id = c("exonA", "exonB", "exonC")
)

input_gr_case1_pot_extended <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 20),
                              end = c(25, 30)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2"),
    old_width = c(6, 11)
)

input_gr_case1_extended_fixed <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 20),
                              end = c(19, 30)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2"),
    old_width = c(6, 11)
)

input_gr_case2_pot_extended <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 20),
                              end = c(25, 25)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2"),
    old_width = c(6, 6)
)

input_gr_case2_extended_fixed <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 20),
                              end = c(19, 25)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2"),
    old_width = c(6, 6)
)

input_gr_case3_pot_extended <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 20),
                              end = c(25, 25)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2"),
    old_width = c(6, 3)
)

input_gr_case3_extended_fixed <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 20),
                              end = c(19, 25)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2"),
    old_width = c(6, 3)
)

input_gr_case4_pot_extended <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 5),
                              end = c(25, 25)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2"),
    old_width = c(6, 18)
)

input_gr_case4_extended_fixed <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 5),
                              end = c(10, 25)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2"),
    old_width = c(6, 18)
)

input_gr_case4bis_pot_extended <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 5),
                              end = c(25, 25)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2"),
    old_width = c(6, 21)
)

input_gr_case4bis_extended_fixed <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 5),
                              end = c(10, 25)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2"),
    old_width = c(6, 21)
)

input_gr_case5_pot_extended <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 20),
                              end = c(25, 25)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2"),
    old_width = c(6, 3)
)

input_gr_case5_extended_fixed <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 20),
                              end = c(19, 25)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2"),
    old_width = c(6, 3)
)

input_gr_case6_pot_extended <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(1, 1, 30),
                              end = c(25, 10, 40)),
    strand = "+",
    gene_id = "gene1",
    transcript_id = c("transcript1", "transcript2", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon1", "exon2"),
    old_width = c(10, 10, 11)
)

input_gr_case6bis_pot_extended <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(1, 1, 30),
                              end = c(25, 10, 40)),
    strand = "+",
    gene_id = c("gene1", "gene2", "gene2"),
    transcript_id = c("transcript1", "transcript2", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2", "exon3"),
    old_width = c(10, 10, 11)
)

input_gr_case7_pot_extended <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(1, 1, 30),
                              end = c(25, 10, 40)),
    strand = "+",
    gene_id = "gene1",
    transcript_id = c("transcript1", "transcript2", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2", "exon3"),
    old_width = c(8, 10, 11)
)

input_gr_case8_pot_extended <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(
        start = c(1, 1, 30),
        end = c(25, 10, 40)
    ),
    strand = "+",
    gene_id = c("gene1", "gene2", "gene2"),
    transcript_id = c("transcript1", "transcript2", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon1", "exon2"),
    old_width = c(8, 10, 11)
)

input_gr_case8_extended_fixed <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(
        start = c(1, 1, 30),
        end = c(8, 10, 40)
    ),
    strand = "+",
    gene_id = c("gene1", "gene2", "gene2"),
    transcript_id = c("transcript1", "transcript2", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon1", "exon2"),
    old_width = c(8, 10, 11)
)

input_gr_case9_pot_extended <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 55),
                              end = c(25, 70)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2"),
    old_width = c(21, 16)
)

input_gr_case10_pot_extended <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(5, 20),
                              end = c(50, 50)),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2"),
    old_width = c(6, 11)
)

test_that("three_prime_pos works", {
    expect_equal(three_prime_pos(input_gr),
                 c(3, 13, 20, 30))
})

test_that("five_prime_pos works", {
    expect_equal(five_prime_pos(input_gr),
                 c(1, 10, 23, 33))
})

test_that("extract_last_exons works", {
    expect_equal(extract_last_exons(input_gr, "gene_id"), input_gr[2:3])
    expect_equal(extract_last_exons(input_gr, "transcript_id"), input_gr[1:3])
    expect_equal(extract_last_exons(input_gr, "gene_id", invert = TRUE),
                 input_gr[c(1, 4)])
    expect_equal(extract_last_exons(input_gr, "transcript_id", invert  = TRUE),
                 input_gr[4])
})

test_that("extend_using_overlap works on basic", {
    expect_equal(
        extend_using_overlap(input_gr, input_gr_to_overlap),
        small_gr_pot_extended
    )
})

test_that("extend_using_overlap works on mixed and unstranded", {
    expect_equal(
        extend_using_overlap(input_gr_case1_10, input_to_overlap_case10),
        input_gr_case10_pot_extended
    )
})

test_that("adjust_for_collision works on no issue", {
    res <- adjust_for_collision(small_gr_pot_extended)
    expect_equal(
        nrow(res$pot_issues),
        0
    )
    expect_equal(
        res$new_gr,
        small_gr_pot_extended
    )
})

test_that("case1 works", {
    expect_equal(
        extend_using_overlap(extract_last_exons(input_gr_case1_10),
                             input_to_overlap_case1_2_3_4_6_7_8),
        subset(
            input_gr_case1_pot_extended,
            old_width != width
        )
    )
    expect_equal(
        adjust_for_collision(input_gr_case1_pot_extended)[["new_gr"]],
        input_gr_case1_extended_fixed
    )
})

test_that("case2 works", {
    expect_equal(
        extend_using_overlap(extract_last_exons(input_gr_case2),
                             input_to_overlap_case1_2_3_4_6_7_8),
        subset(
            input_gr_case2_pot_extended,
            old_width != width
        )
    )
    expect_equal(
        adjust_for_collision(input_gr_case2_pot_extended)[["new_gr"]],
        input_gr_case2_extended_fixed
    )
})

test_that("case3 works", {
    expect_equal(
        extend_using_overlap(extract_last_exons(input_gr_case3_5),
                             input_to_overlap_case1_2_3_4_6_7_8),
        subset(
            input_gr_case3_pot_extended,
            old_width != width
        )
    )
    expect_equal(
        adjust_for_collision(input_gr_case3_pot_extended)[["new_gr"]],
        input_gr_case3_extended_fixed
    )
})

test_that("case4 works", {
    expect_equal(
        extend_using_overlap(extract_last_exons(input_gr_case4),
                             input_to_overlap_case1_2_3_4_6_7_8),
        subset(
            input_gr_case4_pot_extended,
            old_width != width
        )
    )
    expect_equal(
        adjust_for_collision(input_gr_case4_pot_extended)[["new_gr"]],
        input_gr_case4_extended_fixed
    )
})


test_that("case4bis works", {
    expect_equal(
        extend_using_overlap(extract_last_exons(input_gr_case4bis),
                             input_to_overlap_case1_2_3_4_6_7_8),
        subset(
            input_gr_case4bis_pot_extended,
            old_width != width
        )
    )
    expect_equal(
        adjust_for_collision(input_gr_case4bis_pot_extended)[["new_gr"]],
        input_gr_case4bis_extended_fixed
    )
})

test_that("case5 works", {
    expect_equal(
        extend_using_overlap(extract_last_exons(input_gr_case3_5),
                             input_to_overlap_case5_9),
        subset(
            input_gr_case5_pot_extended,
            old_width != width
        )
    )
    expect_equal(
        adjust_for_collision(input_gr_case5_pot_extended)[["new_gr"]],
        input_gr_case5_extended_fixed
    )
})

test_that("case6 works", {
    expect_equal(
        extend_using_overlap(extract_last_exons(input_gr_case6),
                             input_to_overlap_case1_2_3_4_6_7_8),
        subset(
            input_gr_case6_pot_extended,
            old_width != width
        )
    )
    expect_equal(
        adjust_for_collision(input_gr_case6_pot_extended)[["new_gr"]],
        input_gr_case6_pot_extended
    )
})

test_that("case6bis works", {
    expect_equal(
        extend_using_overlap(extract_last_exons(input_gr_case6bis),
                             input_to_overlap_case1_2_3_4_6_7_8),
        subset(
            input_gr_case6bis_pot_extended,
            old_width != width
        )
    )
    expect_equal(
        adjust_for_collision(input_gr_case6bis_pot_extended)[["new_gr"]],
        input_gr_case6bis_pot_extended
    )
    expect_equal(
        sort(adjust_for_collision(
            input_gr_case6bis_pot_extended[c(2,1,3)]
        )[["new_gr"]]),
        sort(input_gr_case6bis_pot_extended)
    )
})

test_that("case7 works", {
    expect_equal(
        extend_using_overlap(extract_last_exons(input_gr_case7),
                             input_to_overlap_case1_2_3_4_6_7_8),
        subset(
            input_gr_case7_pot_extended,
            old_width != width
        )
    )
    expect_equal(
        adjust_for_collision(input_gr_case7_pot_extended)[["new_gr"]],
        input_gr_case7_pot_extended
    )
})

test_that("case8 works", {
    expect_equal(
        extend_using_overlap(extract_last_exons(input_gr_case8),
                             input_to_overlap_case1_2_3_4_6_7_8),
        subset(
            input_gr_case8_pot_extended,
            old_width != width
        )
    )
    expect_equal(
        adjust_for_collision(input_gr_case8_pot_extended)[["new_gr"]],
        input_gr_case8_extended_fixed
    )
})

test_that("filter_new_exons works on case 5_9", {
    res <- GenomicRanges::GRanges(
        seqnames = "chr1",
        ranges = IRanges::IRanges(start = c(1, 33, 45),
                                  end = c(25, 40, 49)),
        strand = "+",
        gene_id = "geneA",
        transcript_id = "transcriptA",
        type = "exon",
        exon_id = c("exonA", "exonB", "exonC"),
        collision_base = c(50, 50, 50)
    )
    names(res$collision_base) <- c("transcriptA", "transcriptA", "transcriptA")
    expect_equal(
        filter_new_exons(
            input_to_overlap_case5_9,
            GenomicRanges::GRanges(
                seqnames = "chr1",
                ranges = IRanges::IRanges(start = c(50),
                                          end = c(75)),
                strand = "+",
                gene_id = "gene1",
                transcript_id = "transcript1",
                type = "exon",
                exon_id = c("exon1")
            )
        ),
        res
    )
})

test_that("add_new_exons works on case 5", {
    expect_equal(
        add_new_exons(
            input_gr_case5_extended_fixed,
            input_to_overlap_case5_9
        ),
        GenomicRanges::GRanges(
            seqnames = "chr1",
            ranges = IRanges::IRanges(start = c(5, 20, 33, 45, 72),
                                      end = c(19, 25, 40, 60, 75)),
            strand = "+",
            gene_id = rep(c("gene1", "gene2"), c(1, 4)),
            transcript_id = rep(c("transcript1", "transcript2"), c(1, 4)),
            type = "exon",
            exon_id = c("exon1", "exon2", "BREW3R0000000001",
                        "BREW3R0000000002", "BREW3R0000000003"),
            old_width = c(6, 3, NA, NA, NA),
            exon_number = c(1, 1:4)
        )
    )
})

test_that("add_new_exons works on case 9", {
    expect_equal(
        add_new_exons(
            input_gr_case9_pot_extended,
            input_to_overlap_case5_9
        ),
        GenomicRanges::GRanges(
            seqnames = "chr1",
            ranges = IRanges::IRanges(start = c(5, 33, 45, 55),
                                      end = c(25, 40, 54, 70)),
            strand = "+",
            gene_id = rep(c("gene1", "gene2"), c(3, 1)),
            transcript_id = rep(c("transcript1", "transcript2"), c(3, 1)),
            type = "exon",
            exon_id = c("exon1", "BREW3R0000000001", "BREW3R0000000002",
                        "exon2"),
            old_width = c(21, NA, NA, 16),
            exon_number = c(1:3, 1)
        )
    )
})


test_that("add_new_exons works when run twice", {
    expect_equal(
        sort(add_new_exons(
            GenomicRanges::GRanges(
                seqnames = "chr1",
                ranges = IRanges::IRanges(start = c(5, 33, 45, 55),
                                          end = c(25, 40, 54, 70)),
                strand = "+",
                gene_id = rep(c("gene1", "gene2"), c(3, 1)),
                transcript_id = rep(c("transcript1", "transcript2"), c(3, 1)),
                type = "exon",
                exon_id = c("exon1", "BREW3R0000000001", "BREW3R0000000002",
                            "exon2"),
                exon_number = c(1:3, 1)
            ),
            GenomicRanges::GRanges(
                seqnames = "chr1",
                ranges = IRanges::IRanges(start = c(60, 92),
                                          end = c(70, 95)),
                strand = "+",
                gene_id = "geneA",
                transcript_id = "transcriptA",
                type = "exon",
                exon_id = c("exonA", "exonB")
            )
        )),
        sort(GenomicRanges::GRanges(
            seqnames = "chr1",
            ranges = IRanges::IRanges(start = c(5, 33, 45, 55, 92),
                                      end = c(25, 40, 54, 70, 95)),
            strand = "+",
            gene_id = rep(c("gene1", "gene2"), c(3, 2)),
            transcript_id = rep(c("transcript1", "transcript2"), c(3, 2)),
            type = "exon",
            exon_id = c("exon1", "BREW3R0000000001", "BREW3R0000000002",
                        "exon2", "BREW3R0000000003"),
            exon_number = c(1:3, 1:2)
        ))
    )
})

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE)

## ----installation bioconductor, eval=FALSE------------------------------------
# if (!require("BiocManager", quietly = TRUE)) {
#     install.packages("BiocManager")
# }
# 
# BiocManager::install("BREW3R.r")

## ----installation github, eval=FALSE------------------------------------------
# if (!require("BiocManager", quietly = TRUE)) {
#     install.packages("BiocManager")
# }
# 
# BiocManager::install("lldelisle/BREW3R.r")

## ----dependencies-------------------------------------------------------------
library(rtracklayer)
library(GenomicRanges)

## ----set file variables-------------------------------------------------------
input_gtf_file_to_extend <-
    system.file(
        "extdata/chr19.gencode.vM25.annotation.gtf.gz",
        package = "BREW3R.r",
        mustWork = TRUE
    )
input_gtf_file_template <-
    system.file(
        "extdata/chr19.mm10.ncbiRefSeq.gtf.gz",
        package = "BREW3R.r",
        mustWork = TRUE
    )

## ----get GRanges--------------------------------------------------------------
input_gr_to_extend <- rtracklayer::import(input_gtf_file_to_extend)
input_gr_template <- rtracklayer::import(input_gtf_file_template)

## ----save CDS-----------------------------------------------------------------
input_gr_CDS <- subset(input_gr_to_extend, type == "CDS")

## ----extend-------------------------------------------------------------------
library(BREW3R.r)
new_gr_exons <- extend_granges(
    input_gr_to_extend = input_gr_to_extend,
    input_gr_to_overlap = input_gr_template
)

## ----plot Btrc, echo=FALSE----------------------------------------------------
my_gene_name <- "Btrc"
gene_before <- subset(
    input_gr_to_extend,
    type == "exon" & gene_name == my_gene_name
)
gene_to_overlap <- subset(
    input_gr_template,
    type == "exon" & gene_name == my_gene_name
)
gene_after <- subset(
    new_gr_exons,
    type == "exon" & gene_name == my_gene_name
)
code <- (runValue(strand(gene_after[1])) == "+") + 1

plot(
    1,
    type = "n", xlab = "", ylab = "", axes = FALSE,
    xlim = c(
        min(start(gene_after)) - 1,
        max(end(gene_after))
    ),
    ylim = c(0, 4)
)
par(las = 1)
axis(2, at = 1:3, labels = c("new gtf", "template", "original"))
arrows(
    x0 = start(gene_before) - 1,
    x1 = end(gene_before),
    y0 = 3, col = "blue",
    code = code
)
arrows(
    x0 = start(gene_to_overlap) - 1,
    x1 = end(gene_to_overlap),
    y0 = 2, col = "red",
    code = code
)
arrows(
    x0 = start(gene_after) - 1,
    x1 = end(gene_after),
    y0 = 1, col = "purple",
    code = code
)

## ----plot Mrpl21, echo=FALSE--------------------------------------------------
my_gene_name <- "Mrpl21"
my_transcript <- "ENSMUST00000155870.1"
gene_before <- subset(
  input_gr_to_extend,
  type == "exon" & gene_name == my_gene_name
)
gene_to_overlap <- subset(
  input_gr_template,
  type == "exon" & gene_name == my_gene_name
)
gene_after <- subset(new_gr_exons, type == "exon" & gene_name == my_gene_name)

code <- (runValue(strand(gene_after[1])) == "+") + 1

plot(1,
     type = "n", xlab = "", ylab = "", axes = FALSE,
     xlim = c(
       min(start(gene_after)) - 1,
       max(end(gene_after))
     ),
     ylim = c(0, 4)
)
par(las = 1)
axis(2, at = 1:3, labels = c("new gtf", "template", "original"))
arrows(
  x0 = start(gene_before) - 1,
  x1 = end(gene_before),
  y0 = 2.8 + 0.4 * as.numeric(gene_before$transcript_id == my_transcript),
  col = "blue",
  code = code
)
arrows(
  x0 = start(gene_to_overlap) - 1,
  x1 = end(gene_to_overlap),
  y0 = 2, col = "red",
  code = code
)
arrows(
  x0 = start(gene_after) - 1,
  x1 = end(gene_after),
  y0 = 0.8 + 0.4 * as.numeric(gene_after$transcript_id == my_transcript),
  col = "purple",
  code = code
)

## ----recompose----------------------------------------------------------------
new_gr <- c(new_gr_exons, input_gr_CDS)

## ----write, eval=FALSE--------------------------------------------------------
# rtracklayer::export.gff(sort(new_gr), "my_new.gtf")

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

#' Extend GRanges
#'
#' A function that from a GRanges from gtf
#' will extend the 3' of transcripts using
#' another GRanges from gtf as a template
#' @param input_gr_to_extend A GRanges to extend
#'                           (only exons are kept and strand * are excluded)
#' @param input_gr_to_overlap A GRanges with intervals to overlap
#' @param extend_existing_exons A boolean that indicates
#'                              if existing exons should be extended
#' @param add_new_exons A boolean that indicates
#'                      if new exons with compatible splicing event
#'                      should be added
#' @param overlap_resolution_fn A file path where the dataframe giving details
#'                              on the collision resolution is written
#' @return A GRanges based on `input_gr_to_extend` where exons are extended
#'         and new exons can be added.
#'         Exons extended will have a '.ext' suffix to the original exon_id.
#'         Exons added will have a exon_id starting with 'BREW3R'.
#' @details
#' During the extension process a special care is taking to prevent extension
#' which would lead to overlap between different gene_ids.
#' @importFrom GenomicRanges strand
#' @export
#' @examples
#' # Very simple case
#' # input_gr:      ------->           ----->
#' # to_overlap:  ------------------>
#'
#' # output:        ---------------->  ----->
#'
#' input_gr <- GenomicRanges::GRanges(
#'     seqnames = "chr1",
#'     ranges = IRanges::IRanges(
#'         start = c(5, 20),
#'         end = c(10, 30)
#'     ),
#'     strand = "+",
#'     gene_id = c("gene1", "gene2"),
#'     transcript_id = c("transcript1", "transcript2"),
#'     type = "exon",
#'     exon_id = c("exon1", "exon2")
#' )
#'
#' input_gr_to_overlap <- GenomicRanges::GRanges(
#'     seqnames = "chr1",
#'     ranges = IRanges::IRanges(
#'         start = 3,
#'         end = 15
#'     ),
#'     strand = "+",
#'     gene_id = "geneA",
#'     transcript_id = "transcriptA",
#'     type = "exon",
#'     exon_id = "exonA"
#' )
#'
#' extend_granges(input_gr, input_gr_to_overlap)
#'
extend_granges <- function(input_gr_to_extend, input_gr_to_overlap,
                           extend_existing_exons = TRUE, add_new_exons = TRUE,
                           overlap_resolution_fn = NULL) {
    # Apply the filters
    input_gr_to_extend <- subset(
        input_gr_to_extend,
        with(
            input_gr_to_extend,
            type == "exon" &
                as.character(strand(input_gr_to_extend)) != "*"
        )
    )

    if (extend_existing_exons) {
        progression_msg("Extend last exons.\nGetting last exons.\n")
        # First get the last exons
        last_exons_gr <- extract_last_exons(input_gr_to_extend)
        rlang::inform(
            paste(
                "Found", length(last_exons_gr),
                "last exons to potentially extend.\n"
            )
        )
        debug_msg("last_exons_gr")
        # Then, these exons are extended ignoring potential collisions
        last_exons_gr_extended <-
            extend_using_overlap(last_exons_gr, input_gr_to_overlap)
        rlang::inform(
            paste(length(last_exons_gr_extended), " exons may be extended.\n")
        )
        progression_msg("Checking for collision with other genes.\n")
        debug_msg("last_exons_gr_extended")
        # Prepare the non-extended exons:
        last_exons_gr_extended$id <-
            paste0(
                last_exons_gr_extended$transcript_id, "_",
                last_exons_gr_extended$exon_id
            )
        input_gr_to_extend$id <- paste0(
            input_gr_to_extend$transcript_id, "_",
            input_gr_to_extend$exon_id
        )
        non_last_exons_extended_gr <- subset(
            input_gr_to_extend,
            with(input_gr_to_extend, !id %in% last_exons_gr_extended$id)
        )
        # Remove the id:
        last_exons_gr_extended$id <- NULL
        non_last_exons_extended_gr$id <- NULL
        # Add needed metadata:
        non_last_exons_extended_gr$old_width <-
            GenomicRanges::width(non_last_exons_extended_gr)
        debug_msg("non_last_exons_extended_gr")
        # Then overlaps are resolved and exons extensions are removed
        # or shortened:
        extension_resolved <- adjust_for_collision(
            c(
                non_last_exons_extended_gr,
                last_exons_gr_extended
            )
        )
        if (!is.null(overlap_resolution_fn)) {
            tryCatch(
                utils::write.table(extension_resolved[["pot_issues"]],
                    overlap_resolution_fn,
                    quote = FALSE, sep = "\t",
                    row.names = FALSE
                ),
                error = function(e) {
                    message("Could not save table.\n Continuing merge.\n")
                }
            )
        }
        debug_msg("extension_resolved$pot_issues")
        extension_resolved_gr <- extension_resolved[["new_gr"]]
        debug_msg("extension_resolved_gr")
        # exon_id of exons changed by BREW3R are modified
        modified <-
            GenomicRanges::width(extension_resolved_gr) !=
                extension_resolved_gr$old_width
        extension_resolved_gr$exon_id[modified] <- paste0(
            extension_resolved_gr$exon_id[modified],
            ".ext"
        )
        rlang::inform(
            paste(
                sum(modified), "exons have been extended",
                "while preventing collision with other genes.\n"
            )
        )
        # We remove old_width
        extension_resolved_gr$old_width <- NULL
        debug_msg("extension_resolved_gr")
    } else {
        extension_resolved_gr <- input_gr_to_extend
    }
    if (add_new_exons) {
        progression_msg("Adding exons after existing ones.\n")
        extension_resolved_gr_new_exons <-
            add_new_exons(
                extension_resolved_gr,
                input_gr_to_overlap
            )
        progression_msg(
            paste(
                "Added",
                length(grep(
                    "BREW3R",
                    extension_resolved_gr_new_exons$exon_id
                )) -
                    length(grep(
                        "BREW3R",
                        extension_resolved_gr$exon_id
                    )),
                " exons.\n"
            )
        )
    } else {
        extension_resolved_gr_new_exons <- extension_resolved_gr
    }
    return(extension_resolved_gr_new_exons)
}

options(rlib_message_verbosity = "quiet")

input_to_overlap_case1_2_3_4_6_7_8 <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = 3,
                              end = 25),
    strand = "+",
    gene_id = "geneA",
    transcript_id = "transcriptA",
    type = "exon",
    exon_id = "exonA"
)
input_to_overlap_case5_9 <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(start = c(1, 33, 45, 72),
                              end = c(25, 40, 60, 75)),
    strand = "+",
    gene_id = "geneA",
    transcript_id = "transcriptA",
    type = "exon",
    exon_id = c("exonA", "exonB", "exonC", "exonD")
)


# Case1:
# input_gene1:      ------->
# input_gene2:                    -------->
# to_overlap:  ---------------------->

test_that("case1 works", {
    expect_equal(
        sort(extend_granges(
            GenomicRanges::GRanges(
                seqnames = "chr1",
                ranges = IRanges::IRanges(start = c(5, 20),
                                          end = c(10, 30)),
                strand = "+",
                gene_id = c("gene1", "gene2"),
                transcript_id = c("transcript1", "transcript2"),
                type = "exon",
                exon_id = c("exon1", "exon2")
            ),
            input_to_overlap_case1_2_3_4_6_7_8
        )),
        GenomicRanges::GRanges(
            seqnames = "chr1",
            ranges = IRanges::IRanges(start = c(5, 20),
                                      end = c(19, 30)),
            strand = "+",
            gene_id = c("gene1", "gene2"),
            transcript_id = c("transcript1", "transcript2"),
            type = "exon",
            exon_id = c("exon1.ext", "exon2")
        )
    )
})

# Case 2:
# input_gene1:      ------->
# input_gene2:                    -------->
# to_overlap:           ------------------>

test_that("case2 works", {
    expect_equal(
        sort(extend_granges(
            GenomicRanges::GRanges(
                seqnames = "chr1",
                ranges = IRanges::IRanges(start = c(5, 20),
                                          end = c(10, 25)),
                strand = "+",
                gene_id = c("gene1", "gene2"),
                transcript_id = c("transcript1", "transcript2"),
                type = "exon",
                exon_id = c("exon1", "exon2")
            ),
            input_to_overlap_case1_2_3_4_6_7_8
        )),
        GenomicRanges::GRanges(
            seqnames = "chr1",
            ranges = IRanges::IRanges(start = c(5, 20),
                                      end = c(19, 25)),
            strand = "+",
            gene_id = c("gene1", "gene2"),
            transcript_id = c("transcript1", "transcript2"),
            type = "exon",
            exon_id = c("exon1.ext", "exon2")
        )
    )
})

# Case 3:
# input_gene1:      ------->
# input_gene2:                    ---->
# to_overlap:       ---------------------->

test_that("case3 works", {
    expect_equal(
        sort(extend_granges(
            GenomicRanges::GRanges(
                seqnames = "chr1",
                ranges = IRanges::IRanges(start = c(5, 20),
                                          end = c(10, 22)),
                strand = "+",
                gene_id = c("gene1", "gene2"),
                transcript_id = c("transcript1", "transcript2"),
                type = "exon",
                exon_id = c("exon1", "exon2")
            ),
            input_to_overlap_case1_2_3_4_6_7_8
        )),
        GenomicRanges::GRanges(
            seqnames = "chr1",
            ranges = IRanges::IRanges(start = c(5, 20),
                                      end = c(19, 25)),
            strand = "+",
            gene_id = c("gene1", "gene2"),
            transcript_id = c("transcript1", "transcript2"),
            type = "exon",
            exon_id = c("exon1.ext", "exon2.ext")
        )
    )
})

# Case 4:
# input_gene1:      ------->
# input_gene2:      ------------->
# to_overlap:       ---------------------->

test_that("case4 works", {
    expect_equal(
        sort(extend_granges(
            GenomicRanges::GRanges(
                seqnames = "chr1",
                ranges = IRanges::IRanges(start = c(5, 5),
                                          end = c(10, 22)),
                strand = "+",
                gene_id = c("gene1", "gene2"),
                transcript_id = c("transcript1", "transcript2"),
                type = "exon",
                exon_id = c("exon1", "exon2")
            ),
            input_to_overlap_case1_2_3_4_6_7_8
        )),
        GenomicRanges::GRanges(
            seqnames = "chr1",
            ranges = IRanges::IRanges(start = c(5, 5),
                                      end = c(10, 25)),
            strand = "+",
            gene_id = c("gene1", "gene2"),
            transcript_id = c("transcript1", "transcript2"),
            type = "exon",
            exon_id = c("exon1", "exon2.ext")
        )
    )
})

# Case 5:
# input_gene1:      ------->
# input_gene2:                    -------->
# to_overlap:           ----------------------/\----/\-/\->

test_that("case5 works", {
    expect_equal(
        sort(extend_granges(
            GenomicRanges::GRanges(
                seqnames = "chr1",
                ranges = IRanges::IRanges(start = c(5, 20),
                                          end = c(10, 22)),
                strand = "+",
                gene_id = c("gene1", "gene2"),
                transcript_id = c("transcript1", "transcript2"),
                type = "exon",
                exon_id = c("exon1", "exon2")
            ),
            input_to_overlap_case5_9
        )),
        GenomicRanges::GRanges(
            seqnames = "chr1",
            ranges = IRanges::IRanges(start = c(5, 20, 33, 45, 72),
                                      end = c(19, 25, 40, 60, 75)),
            strand = "+",
            gene_id = rep(c("gene1", "gene2"), c(1, 4)),
            transcript_id = rep(c("transcript1", "transcript2"), c(1, 4)),
            type = "exon",
            exon_id = c("exon1.ext", "exon2.ext", "BREW3R0000000001",
                        "BREW3R0000000002", "BREW3R0000000003"),
            exon_number = c(1, 1:4)
        )
    )
})

# Case 6:
# input_transcript1:     --------->
# input_transcript2:     ----------/        \-------->
# to_overlap:               ----------->

test_that("case6 works", {
    expect_equal(
        sort(extend_granges(
            GenomicRanges::GRanges(
                seqnames = "chr1",
                ranges = IRanges::IRanges(start = c(1, 1, 30),
                                          end = c(10, 10, 40)),
                strand = "+",
                gene_id = "gene1",
                transcript_id = c("transcript1", "transcript2", "transcript2"),
                type = "exon",
                exon_id = c("exon1", "exon1", "exon2")
            ),
            input_to_overlap_case1_2_3_4_6_7_8
        )),
        sort(GenomicRanges::GRanges(
            seqnames = "chr1",
            ranges = IRanges::IRanges(start = c(1, 1, 30),
                                      end = c(25, 10, 40)),
            strand = "+",
            gene_id = "gene1",
            transcript_id = c("transcript1", "transcript2", "transcript2"),
            type = "exon",
            exon_id = c("exon1.ext", "exon1", "exon2")
        ))
    )
})

# Case 6bis:
# input_gene1:     --------->
# input_gene2:     ----------/        \-------->
# to_overlap:          ----------->

test_that("case6bis works", {
    expect_equal(
        sort(extend_granges(
            GenomicRanges::GRanges(
                seqnames = "chr1",
                ranges = IRanges::IRanges(start = c(1, 1, 30),
                                          end = c(10, 10, 40)),
                strand = "+",
                gene_id = c("gene1", "gene2", "gene2"),
                transcript_id = c("transcript1", "transcript2", "transcript2"),
                type = "exon",
                exon_id = c("exon1", "exon2", "exon3")
            ),
            input_to_overlap_case1_2_3_4_6_7_8
        )),
        sort(GenomicRanges::GRanges(
            seqnames = "chr1",
            ranges = IRanges::IRanges(start = c(1, 1, 30),
                                      end = c(25, 10, 40)),
            strand = "+",
            gene_id = c("gene1", "gene2", "gene2"),
            transcript_id = c("transcript1", "transcript2", "transcript2"),
            type = "exon",
            exon_id = c("exon1.ext", "exon2", "exon3")
        ))
    )
})
# Case 7:
# input_transcript1:     ------>
# input_transcript2:     ----------/        \-------->
# to_overlap:               ----------->

test_that("case7 works", {
    expect_equal(
        sort(extend_granges(
            GenomicRanges::GRanges(
                seqnames = "chr1",
                ranges = IRanges::IRanges(start = c(1, 1, 30),
                                          end = c(8, 10, 40)),
                strand = "+",
                gene_id = "gene1",
                transcript_id = c("transcript1", "transcript2", "transcript2"),
                type = "exon",
                exon_id = c("exon1", "exon2", "exon3")
            ),
            input_to_overlap_case1_2_3_4_6_7_8
        )),
        sort(GenomicRanges::GRanges(
            seqnames = "chr1",
            ranges = IRanges::IRanges(start = c(1, 1, 30),
                                      end = c(25, 10, 40)),
            strand = "+",
            gene_id = "gene1",
            transcript_id = c("transcript1", "transcript2", "transcript2"),
            type = "exon",
            exon_id = c("exon1.ext", "exon2", "exon3")
        ))
    )
})

# Case 8 should not be extended:
# input_gene1:        ----->
# input_gene2:     ----------------/      \--------
# to_overlap:      ------------------>

test_that("case8 works", {
    expect_equal(
        sort(extend_granges(
            GenomicRanges::GRanges(
                seqnames = "chr1",
                ranges = IRanges::IRanges(start = c(1, 1, 30),
                                          end = c(8, 10, 40)),
                strand = "+",
                gene_id = c("gene1", "gene2", "gene2"),
                transcript_id = c("transcript1", "transcript2", "transcript2"),
                type = "exon",
                exon_id = c("exon1", "exon2", "exon3")
            ),
            input_to_overlap_case1_2_3_4_6_7_8
        )),
        sort(GenomicRanges::GRanges(
            seqnames = "chr1",
            ranges = IRanges::IRanges(start = c(1, 1, 30),
                                      end = c(8, 10, 40)),
            strand = "+",
            gene_id = c("gene1", "gene2", "gene2"),
            transcript_id = c("transcript1", "transcript2", "transcript2"),
            type = "exon",
            exon_id = c("exon1", "exon2", "exon3")
        ))
    )
})

# Case 9:
# input_gene1:  --->
# input_gene2:                   --->
# to_overlap:   ----/\--------/\---/  \---->

test_that("case9 works with debug and overlapresolution", {
    rlang::local_options(BREW3R.r.verbose = "debug")
    overlap_resolution_fn <- tempfile()
    expect_equal(
        sort(extend_granges(
            GenomicRanges::GRanges(
                seqnames = "chr1",
                ranges = IRanges::IRanges(start = c(5, 55),
                                          end = c(10, 70)),
                strand = "+",
                gene_id = c("gene1", "gene2"),
                transcript_id = c("transcript1", "transcript2"),
                type = "exon",
                exon_id = c("exon1", "exon2")
            ),
            input_to_overlap_case5_9,
            overlap_resolution_fn = overlap_resolution_fn
        )),
        GenomicRanges::GRanges(
            seqnames = "chr1",
            ranges = IRanges::IRanges(start = c(5, 33, 45, 55),
                                      end = c(25, 40, 54, 70)),
            strand = "+",
            gene_id = rep(c("gene1", "gene2"), c(3, 1)),
            transcript_id = rep(c("transcript1", "transcript2"), c(3, 1)),
            type = "exon",
            exon_id = c("exon1.ext", "BREW3R0000000001",
                        "BREW3R0000000002", "exon2"),
            exon_number = c(1:3, 1)
        )
    )
})

---
title: "BREW3R.r"
author: "Lucille Lopez-Delisle"
date: "2024-02-21"
output:
  BiocStyle::html_document:
    toc: true
    toc_depth: 2
vignette: >
  %\VignetteIndexEntry{BREW3R.r}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
  
```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

# Introduction

The **BREW3R.r** package has been written to be part of the BREW3R workflow.
Today, the package contains a single function which enable to extend three prime
of gene annotations using another gene annotation as template.
This is very helpful when you are using a technique that only sequence
three-prime end of genes like 10X scRNA-seq or BRB-seq.

# Installation

To install from Bioconductor use:

```{r installation bioconductor, eval=FALSE}
if (!require("BiocManager", quietly = TRUE)) {
    install.packages("BiocManager")
}

BiocManager::install("BREW3R.r")
```

To install from github use:

```{r installation github, eval=FALSE}
if (!require("BiocManager", quietly = TRUE)) {
    install.packages("BiocManager")
}

BiocManager::install("lldelisle/BREW3R.r")
```

# Example

## Load dependencies

```{r dependencies}
library(rtracklayer)
library(GenomicRanges)
```

## Get gtfs

In this example, I will extend the transcripts from gencode using
RefSeq on mm10. In order to decrease the size of the input files, the input
files of this vignette have been subsetted to the chromosome 19.
Original gtf for gencode is available
[here](https://ftp.ebi.ac.uk/pub/databases/gencode/Gencode_mouse/release_M25/gencode.vM25.annotation.gtf.gz)
and gtf for RefSeq is available
[here](https://hgdownload.soe.ucsc.edu/goldenPath/mm10/bigZips/genes/mm10.ncbiRefSeq.gtf.gz).

```{r set file variables}
input_gtf_file_to_extend <-
    system.file(
        "extdata/chr19.gencode.vM25.annotation.gtf.gz",
        package = "BREW3R.r",
        mustWork = TRUE
    )
input_gtf_file_template <-
    system.file(
        "extdata/chr19.mm10.ncbiRefSeq.gtf.gz",
        package = "BREW3R.r",
        mustWork = TRUE
    )
```

## Convert gtf files to GRanges

We will use the rtracklayer package to import gtf:

```{r get GRanges}
input_gr_to_extend <- rtracklayer::import(input_gtf_file_to_extend)
input_gr_template <- rtracklayer::import(input_gtf_file_template)
```

## Save annotations

The package only use exon information.
It may be interesting to save the other annotations like 'CDS',
'start_codon', 'end_codon'.

You should not save the 'gene' and 'transcript' annotations as they will be out
of date. Same for three prime UTR.

```{r save CDS}
input_gr_CDS <- subset(input_gr_to_extend, type == "CDS")
```

## Extend the GRanges

Now we can run the main function of the package:

```{r extend}
library(BREW3R.r)
new_gr_exons <- extend_granges(
    input_gr_to_extend = input_gr_to_extend,
    input_gr_to_overlap = input_gr_template
)
```

By default, you get few statistics. You can change the verbosity with
`options(rlib_message_verbosity = "quiet")` to mute it or on the contrary
you can set `options(BREW3R.r.verbose = "progression")` to get messages with
all steps.
Among them, you can read that you extended about half of last exons,
then you could add 29 exons to 26 transcripts.

## Explore your data

Here is an example for the Btrc gene that have been extended:

```{r plot Btrc, echo=FALSE}
my_gene_name <- "Btrc"
gene_before <- subset(
    input_gr_to_extend,
    type == "exon" & gene_name == my_gene_name
)
gene_to_overlap <- subset(
    input_gr_template,
    type == "exon" & gene_name == my_gene_name
)
gene_after <- subset(
    new_gr_exons,
    type == "exon" & gene_name == my_gene_name
)
code <- (runValue(strand(gene_after[1])) == "+") + 1

plot(
    1,
    type = "n", xlab = "", ylab = "", axes = FALSE,
    xlim = c(
        min(start(gene_after)) - 1,
        max(end(gene_after))
    ),
    ylim = c(0, 4)
)
par(las = 1)
axis(2, at = 1:3, labels = c("new gtf", "template", "original"))
arrows(
    x0 = start(gene_before) - 1,
    x1 = end(gene_before),
    y0 = 3, col = "blue",
    code = code
)
arrows(
    x0 = start(gene_to_overlap) - 1,
    x1 = end(gene_to_overlap),
    y0 = 2, col = "red",
    code = code
)
arrows(
    x0 = start(gene_after) - 1,
    x1 = end(gene_after),
    y0 = 1, col = "purple",
    code = code
)
```

Here is an example for the Mrpl21 gene that have a new exon
on the 3' end of one of its transcript:

```{r plot Mrpl21, echo=FALSE}
my_gene_name <- "Mrpl21"
my_transcript <- "ENSMUST00000155870.1"
gene_before <- subset(
  input_gr_to_extend,
  type == "exon" & gene_name == my_gene_name
)
gene_to_overlap <- subset(
  input_gr_template,
  type == "exon" & gene_name == my_gene_name
)
gene_after <- subset(new_gr_exons, type == "exon" & gene_name == my_gene_name)

code <- (runValue(strand(gene_after[1])) == "+") + 1

plot(1,
     type = "n", xlab = "", ylab = "", axes = FALSE,
     xlim = c(
       min(start(gene_after)) - 1,
       max(end(gene_after))
     ),
     ylim = c(0, 4)
)
par(las = 1)
axis(2, at = 1:3, labels = c("new gtf", "template", "original"))
arrows(
  x0 = start(gene_before) - 1,
  x1 = end(gene_before),
  y0 = 2.8 + 0.4 * as.numeric(gene_before$transcript_id == my_transcript),
  col = "blue",
  code = code
)
arrows(
  x0 = start(gene_to_overlap) - 1,
  x1 = end(gene_to_overlap),
  y0 = 2, col = "red",
  code = code
)
arrows(
  x0 = start(gene_after) - 1,
  x1 = end(gene_after),
  y0 = 0.8 + 0.4 * as.numeric(gene_after$transcript_id == my_transcript),
  col = "purple",
  code = code
)
```

## Recompose the GRanges

We can put back annotations that have been stored:

```{r recompose}
new_gr <- c(new_gr_exons, input_gr_CDS)
```

## Write new GRanges to gtf

```{r write, eval=FALSE}
rtracklayer::export.gff(sort(new_gr), "my_new.gtf")
```

# Session Info

```{r sessionInfo}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/messages.R
\name{progression_msg}
\alias{progression_msg}
\title{Display progression messages if verbose allows it}
\usage{
progression_msg(...)
}
\arguments{
\item{...}{Parameters for rlang::inform}
}
\value{
Nothing
}
\description{
A function that extend rlang::inform
to display a message if the verbose is at "debug" or "progression"
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helpers.R
\name{extend_using_overlap}
\alias{extend_using_overlap}
\title{Overlap exons and extend three prime end}
\usage{
extend_using_overlap(input_gr_to_extend, input_gr_to_overlap)
}
\arguments{
\item{input_gr_to_extend}{A GRanges with exons to extend
(strand * are excluded)}

\item{input_gr_to_overlap}{A GRanges with intervals to overlap}
}
\value{
A GRanges which is a subset of `input_gr_to_extend` where
        3' end have been modified to match the 3' end of
        `input_gr_to_overlap` if they overlap
        (initial width have been stored into old_width)
}
\description{
A function that from 2 GRanges returns a subset of the first
GRanges which have been extended using the second GRanges
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extend_granges.R
\name{extend_granges}
\alias{extend_granges}
\title{Extend GRanges}
\usage{
extend_granges(
  input_gr_to_extend,
  input_gr_to_overlap,
  extend_existing_exons = TRUE,
  add_new_exons = TRUE,
  overlap_resolution_fn = NULL
)
}
\arguments{
\item{input_gr_to_extend}{A GRanges to extend
(only exons are kept and strand * are excluded)}

\item{input_gr_to_overlap}{A GRanges with intervals to overlap}

\item{extend_existing_exons}{A boolean that indicates
if existing exons should be extended}

\item{add_new_exons}{A boolean that indicates
if new exons with compatible splicing event
should be added}

\item{overlap_resolution_fn}{A file path where the dataframe giving details
on the collision resolution is written}
}
\value{
A GRanges based on `input_gr_to_extend` where exons are extended
        and new exons can be added.
        Exons extended will have a '.ext' suffix to the original exon_id.
        Exons added will have a exon_id starting with 'BREW3R'.
}
\description{
A function that from a GRanges from gtf
will extend the 3' of transcripts using
another GRanges from gtf as a template
}
\details{
During the extension process a special care is taking to prevent extension
which would lead to overlap between different gene_ids.
}
\examples{
# Very simple case
# input_gr:      ------->           ----->
# to_overlap:  ------------------>

# output:        ---------------->  ----->

input_gr <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(
        start = c(5, 20),
        end = c(10, 30)
    ),
    strand = "+",
    gene_id = c("gene1", "gene2"),
    transcript_id = c("transcript1", "transcript2"),
    type = "exon",
    exon_id = c("exon1", "exon2")
)

input_gr_to_overlap <- GenomicRanges::GRanges(
    seqnames = "chr1",
    ranges = IRanges::IRanges(
        start = 3,
        end = 15
    ),
    strand = "+",
    gene_id = "geneA",
    transcript_id = "transcriptA",
    type = "exon",
    exon_id = "exonA"
)

extend_granges(input_gr, input_gr_to_overlap)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helpers.R
\name{overlap_different_genes}
\alias{overlap_different_genes}
\title{Get overlaps from different genes}
\usage{
overlap_different_genes(gr1, gr2)
}
\arguments{
\item{gr1}{A GRanges with 'gene_id'}

\item{gr2}{A GRanges with 'gene_id'}
}
\value{
a data.frame with overlaps between gr1 and gr2 when gene_id from gr1
        is different from gene_id from gr2. The data.frame has 4 columns:
        `queryHits`, `subjectHits`, `query_gene_id` and `subject_gene_id`
}
\description{
A function that from 2 GRanges generates a dataframe
With queryHits, subjectHits when the gene_id is different
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helpers.R
\name{extract_last_exons}
\alias{extract_last_exons}
\title{Extract last exons}
\usage{
extract_last_exons(
  input_gr,
  grouping_variable = "transcript_id",
  invert = FALSE
)
}
\arguments{
\item{input_gr}{A GRanges from a gtf}

\item{grouping_variable}{A string with the name of the metadata
which should be used to group}

\item{invert}{A boolean that indicates if you want all except the last exons}
}
\value{
A GRanges which contains a subset of `input_gr`
}
\description{
A function that from a GRanges from gtf
select only entries for the last exons
If multiple exons overlap the last base of the grouping_variable,
they will all be reported.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helpers.R
\name{adjust_for_collision}
\alias{adjust_for_collision}
\title{Adjust for collision}
\usage{
adjust_for_collision(input_gr)
}
\arguments{
\item{input_gr}{A GRanges with 1 meta: 'old_width'}
}
\value{
A list with:
        - 'pot_issues': A dataframe with exons which overlaps between
                       `input_gr` and itself while gene_ids are different
        - 'new_gr': A GRanges identical to `input_gr` except that start/end
                    have been adjusted to prevent collisions.
}
\description{
A function that from a GRanges with 'old_width'
Change the starts and ends to prevent collisions larger than
with old coordinates
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/messages.R
\name{debug_msg}
\alias{debug_msg}
\title{Display debug messages if verbose allows it}
\usage{
debug_msg(message = NULL, ...)
}
\arguments{
\item{message}{String to display}

\item{...}{Other parameters for rlang::inform}
}
\value{
Nothing
}
\description{
A function that extend rlang::inform
to display a message if the verbose is at "debug"
and show content of the variable
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helpers.R
\name{filter_new_exons}
\alias{filter_new_exons}
\title{Filter new exons for collision}
\usage{
filter_new_exons(all_exons_interesting, input_gr_to_extend)
}
\arguments{
\item{all_exons_interesting}{A GRanges with exons to trim and filter}

\item{input_gr_to_extend}{A GRanges to overlap}
}
\value{
A GRanges subset of `all_exons_interesting`
}
\description{
A function that from 2 GRanges filter exons from the first one
so they do not go three prime to the first collision with the second one.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helpers.R
\name{three_prime_pos}
\alias{three_prime_pos}
\title{Get three prime position}
\usage{
three_prime_pos(input_gr)
}
\arguments{
\item{input_gr}{A GRanges or GRangeList}
}
\value{
A vector of integers
}
\description{
A function that from a GRanges
gives the 3' position
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helpers.R
\name{add_new_exons}
\alias{add_new_exons}
\title{Add new exons}
\usage{
add_new_exons(input_gr_to_extend, input_gr_with_new_exons)
}
\arguments{
\item{input_gr_to_extend}{A GRanges to be complemented}

\item{input_gr_with_new_exons}{A GRanges with exons to be added
to the first one (exons with strand '*' are excluded)}
}
\value{
A GRanges identical to `input_gr_to_extend` with new exons
        whose `exon_id` contains BREW3R. `exon_number` may have changed.
}
\description{
A function that from 2 GRanges add exons from the second one
to the first one
if the 3p of the last exon of the transcript in the first GRanges
matches the 3p of an exon in the second one
}
\details{
Potential new exons will be filtered for collision with exons present
in the first GRanges even if they belong to the same gene_id.
For the moment all potential exons extensions are added to the
same existing transcript_id so introns maybe artificial introns.
}
